// adpated from http://www.embeddedheaven.com/linux-semaphore-tutorial.htm
// Linux semaphore tutorial By Admin
// Embedded Linux, parallel programming

/* Includes */
#include <unistd.h>     /* Symbolic Constants */
#include <sys/types.h>  /* Primitive System Data Types */
#include <errno.h>      /* Errors */
#include <stdio.h>      /* Input/Output */
#include <stdlib.h>     /* General Utilities */
#include <pthread.h>    /* POSIX Threads */
#include <string.h>     /* String handling */
#include <semaphore.h>  /* Semaphore */

/* prototype for thread routine */
void *handler ( void *ptr );

/* global vars */
/* semaphores are declared global so they can be accessed
   in main() and in thread routine,
   here, the semaphore is used as a mutex */
sem_t mutex;
int counter; /* shared variable */

int main()
{
  int i[2];
  pthread_t thread_a;
  pthread_t thread_b;

  i[0] = 0; /* argument to threads */
  i[1] = 1;

  sem_init(&mutex, 0, 1);      /* initialize mutex to 1 - binary semaphore */
  /* second param = 0 - semaphore is local */

  /* Note: you can check if thread has been successfully created by checking return value of
     pthread_create */
  //  pthread_create (&thread_a, NULL, (void *) &handler, (void *)&i[0]);
  pthread_create (&thread_b, NULL, handler, (void *)&i[1]);

  pthread_create (&thread_a, NULL, handler, (void*)&i[0]);
  pthread_join(thread_a, NULL);
  pthread_join(thread_b, NULL);

  sem_destroy(&mutex); /* destroy semaphore */

  /* exit */
  exit(0);
} /* main() */

void *handler ( void *ptr )
{
  int x;
  x = *((int *) ptr);
  printf("Thread %d: Waiting to enter critical region...\n", x);
  sem_wait(&mutex);       /* down semaphore */
  /* START CRITICAL REGION */
  printf("Thread %d: Now in critical region...\n", x);
  printf("Thread %d: Counter Value: %d\n", x, counter);
  printf("Thread %d: Incrementing Counter...\n", x);
  counter++;
  sleep(2);
  printf("Thread %d: New Counter Value: %d\n", x, counter);
  printf("Thread %d: Exiting critical region...\n", x);
  /* END CRITICAL REGION */
  sem_post(&mutex);       /* up semaphore */

  pthread_exit(0); /* exit thread */
}  
